<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<link rel="alternate"
      type="application/rss+xml"
      href="https://blog.winny.tech/rss.xml"
      title="RSS feed for https://blog.winny.tech/"/>
<title>Some tips when copying, recovering disks</title>

<link href="static/style.css?v=1.13" rel="stylesheet" type="text/css" />
<meta name="viewport" content="width=device-width, initial-scale=1">
</head>
<body>
<div id="preamble" class="status">

<nav>
<div class="flexcontainer">
<div class="smallitem">
<ul class="inline-list">
<li><a href=".">blog.winny.tech</a></li>
<li><a href="https://winny.tech/">About</a></li>
</ul>
</div>
<div class="bigitem">
<ul class="inline-list">
<li><a href="archive.html">Archive</a></li>
<li><a href="tags.html">Tags</a></li>
<li><a href="rss.xml">RSS Feed</a></li>
</ul>
</div>
</div>
</nav>
<hr/>
</div>
<div id="content">
<div class="post-date">14 Mar 2021</div><h1 class="post-title"><a href="2021-03-14-some-tips-when-copying-recovering-disks.html">Some tips when copying, recovering disks</a></h1>
<nav id="table-of-contents">
<h2>Table of Contents</h2>
<div id="text-table-of-contents">
<ul>
<li><a href="#org61f3897">1. Use the right tools for the job</a></li>
<li><a href="#orgb4ac0a7">2. Finding the disk/partitions to work with</a></li>
<li><a href="#org1cd34c5">3. Write/read to the least ambiguous device file</a></li>
<li><a href="#org69d37c2">4. Use GNU <code>ddrescue</code></a></li>
<li><a href="#org75e017f">5. Monitor dmesg for errors</a></li>
<li><a href="#org0ce9273">6. Always run your task in a tmux or screen session</a></li>
<li><a href="#org518ed30">7. Wiping disks</a></li>
<li><a href="#orgd48d6b6">8. Conclusion</a></li>
</ul>
</div>
</nav>
<p>
I seem to have a lot of suggestions to share with friends about managing disks
on a linux livecd.  Here are some of the tips I'd like to share.  See the table
of contents above for a breakdown of the topics discussed.
</p>

<p>
Some disk related topics are out of scope for this article, as they deserve
their own blog post.  The topics not covered include partitioning, setting up a
boot loader, using LVM2 or ZFS, that sort of thing.  This is more about working
with existing data, and general advice.
</p>

<div id="outline-container-org61f3897" class="outline-2">
<h2 id="org61f3897"><span class="section-number-2">1</span> Use the right tools for the job</h2>
<div class="outline-text-2" id="text-1">
<p>
Much of this article is about using the right tools for the job, but first I
want to recommend checking out the <a href="https://grml.org/">GRML Linux LiveCD</a>.  It isn't super
flashy, but it gets the job done, ships with virtually every tool a competent
Linux user would need to fix up a system.  Maybe write it to a usb using
<a href="https://grml.org/grml2usb/"><code>grml2usb</code></a> and use <a href="https://wiki.grml.org/doku.php?id=persistency">persistence</a>.  This way you can keep your terminal
hardcopies/logs handy.
</p>

<a href="static/image/grml_grub.png">

<figure>
<img src="static/image/grml_grub.png" alt="grml_grub.png">

</figure>
</a>
</div>
</div>

<div id="outline-container-orgb4ac0a7" class="outline-2">
<h2 id="orgb4ac0a7"><span class="section-number-2">2</span> Finding the disk/partitions to work with</h2>
<div class="outline-text-2" id="text-2">
<p>
My usual way is to first check <code>dmesg</code> output for detection of storage
devices.  It will look something like this:
</p>

<pre class="example">
[    1.611027] ata2.00: ATA-10: ST4000DM004-2CV104, 0001, max UDMA/133
[    1.611029] ata2.00: 7814037168 sectors, multi 16: LBA48 NCQ (depth 32), AA
[    1.661247] ata2.00: configured for UDMA/133
[    1.661570] scsi 2:0:0:0: Direct-Access     ATA      ST4000DM004-2CV1 0001 PQ: 0 ANSI: 5
[    1.661653] sd 2:0:0:0: Attached scsi generic sg1 type 0
[    1.661663] sd 2:0:0:0: [sdb] 7814037168 512-byte logical blocks: (4.00 TB/3.64 TiB)
[    1.661664] sd 2:0:0:0: [sdb] 4096-byte physical blocks
[    1.661668] sd 2:0:0:0: [sdb] Write Protect is off
[    1.661669] sd 2:0:0:0: [sdb] Mode Sense: 00 3a 00 00
[    1.661675] sd 2:0:0:0: [sdb] Write cache: enabled, read cache: enabled, doesn't support DPO or FUA
[    1.688240] sd 2:0:0:0: [sdb] Attached SCSI removable disk
</pre>

<p>
Then if unsure I like to check the output of <code>lsblk</code> and <code>parted -l</code><sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup>.  They
look like this:
</p>

<pre class="example">
$ lsblk
NAME                                          MAJ:MIN RM   SIZE RO TYPE  MOUNTPOINT
sda                                             8:0    1   3.7T  0 disk  
└─md127                                         9:127  0   3.7T  0 raid1 
  └─GreenCrypt                                253:3    0   3.7T  0 crypt 
    ├─Green-docker                            253:4    0   100G  0 lvm   /var/lib/docker
    ├─Green-binpkgs                           253:5    0   100G  0 lvm   /var/cache/binpkgs
    ├─Green-distfiles                         253:6    0   100G  0 lvm   /var/cache/distfiles
    ├─Green-main                              253:7    0     1T  0 lvm   /mnt/stuff
    ├─Green-games                             253:8    0   750G  0 lvm   /mnt/games
    ├─Green-vm                                253:9    0   250G  0 lvm   
    └─Green-wine                              253:10   0   250G  0 lvm   
sdb                                             8:16   1   3.7T  0 disk  
└─md127                                         9:127  0   3.7T  0 raid1 
  └─GreenCrypt                                253:3    0   3.7T  0 crypt 
    ├─Green-docker                            253:4    0   100G  0 lvm   /var/lib/docker
    ├─Green-binpkgs                           253:5    0   100G  0 lvm   /var/cache/binpkgs
    ├─Green-distfiles                         253:6    0   100G  0 lvm   /var/cache/distfiles
    ├─Green-main                              253:7    0     1T  0 lvm   /mnt/stuff
    ├─Green-games                             253:8    0   750G  0 lvm   /mnt/games
    ├─Green-vm                                253:9    0   250G  0 lvm   
    └─Green-wine                              253:10   0   250G  0 lvm   
sr0                                            11:0    1     2K  0 rom   
nvme0n1                                       259:0    0 931.5G  0 disk  
├─nvme0n1p1                                   259:1    0     2M  0 part  
├─nvme0n1p2                                   259:2    0   977M  0 part  /boot
└─nvme0n1p3                                   259:3    0 930.6G  0 part  
  └─luks-27598b7a-dbfd-4e5a-a5b1-4de8618b66ed 253:0    0 930.6G  0 crypt 
    ├─Gentoo-Root                             253:1    0   250G  0 lvm   /
    └─Gentoo-Home                             253:2    0   250G  0 lvm   /home
</pre>

<p>
and <code>parted -l</code>:
</p>

<pre class="example">
$ sudo parted -l
Error: /dev/sda: unrecognised disk label
Model: ATA ST4000DM004-2CV1 (scsi)                                        
Disk /dev/sda: 4001GB
Sector size (logical/physical): 512B/4096B
Partition Table: unknown
Disk Flags: 

Error: /dev/sdb: unrecognised disk label
Model: ATA ST4000DM004-2CV1 (scsi)                                        
Disk /dev/sdb: 4001GB
Sector size (logical/physical): 512B/4096B
Partition Table: unknown
Disk Flags: 

Model: Samsung SSD 980 PRO 1TB (nvme)
Disk /dev/nvme0n1: 1000GB
Sector size (logical/physical): 512B/512B
Partition Table: gpt
Disk Flags: 

Number  Start   End     Size    File system  Name   Flags
 1      1049kB  3146kB  2097kB               grub   bios_grub
 2      3146kB  1028MB  1024MB  fat32        boot   boot, esp
 3      1028MB  1000GB  999GB                crypt


Error: /dev/md127: unrecognised disk label
Model: Linux Software RAID Array (md)                                     
Disk /dev/md127: 4001GB
Sector size (logical/physical): 512B/4096B
Partition Table: unknown
Disk Flags: 
</pre>

<p>
Just a brief note on the above outputs.  The astute reader will notice that the
two <code>/dev/sdX</code> disks have no partitioning.  This is intentional.  They form a
Linux md RAID1 (mirror) with a LUKS volume on top of it.  In the LUKS volume is
a LVM2 volume group with logical volumes containing filesystems.  The attentive
reader will also notice my NVME device has a tiny partition called <code>grub</code> and a
<code>boot</code> partition.  The tiny partition has a BIOS MBR bootblock so if I boot
the drive on a Legacy BIOS system, it will work fine.  It will also boot fine
on a EFI system.
</p>
</div>
</div>

<div id="outline-container-org1cd34c5" class="outline-2">
<h2 id="org1cd34c5"><span class="section-number-2">3</span> Write/read to the least ambiguous device file</h2>
<div class="outline-text-2" id="text-3">
<p>
On Linux there is a directory in the dev filesystem called <code>/dev/disk</code> within
it is subdirectories that each contain symbolic links to top a device file
referring to a disk or partition.
</p>

<p>
When referring to a specific disk, use <code>/dev/disk/by-id/…</code>.  Use this when
doing a disk wiping or copying operation.  To figure out which symbolic link
belongs to a given disk or partition, (1) figure out how the device is known to
the kernel [e.g. SATA/ATA, DM, LVM, MD, NVME, etc.] and (2) Determine the
vendor or identifying bits.  For example in the following listing
<code>ata-ST4000DM004-2CV104_ZFN3QBWB</code> indicates the way the kernel knows about it
(<code>ata</code>), the model (<code>ST4000DM004</code>), and the serial number
(<code>2CV104_ZFN3QBWB</code>).  Example listing:
</p>

<pre class="example">
$ ls /dev/disk/by-id/
ata-HL-DT-ST_BD-RE_WH16NS60_KLZKBPA5625
ata-ST4000DM004-2CV104_ZFN3QBWB
ata-ST4000DM004-2CV104_ZFN3QE4B
dm-name-Gentoo-Home
dm-name-Gentoo-Root
dm-name-Green-binpkgs
dm-name-GreenCrypt
dm-name-Green-distfiles
dm-name-Green-docker
dm-name-Green-games
dm-name-Green-main
dm-name-Green-vm
dm-name-Green-wine
dm-name-luks-27598b7a-dbfd-4e5a-a5b1-4de8618b66ed
dm-uuid-CRYPT-LUKS1-27598b7adbfd4e5aa5b14de8618b66ed-luks-27598b7a-dbfd-4e5a-a5b1-4de8618b66ed
dm-uuid-CRYPT-LUKS2-704eca588f574f53989e56511d731366-GreenCrypt
dm-uuid-LVM-Mn6J1pC3IAss0h6SeXMprDWETuJIO1u12TZqwz7032u90NNlBZAZKka3q1MBPDQX
dm-uuid-LVM-Mn6J1pC3IAss0h6SeXMprDWETuJIO1u1dOHiDShY70TBuOwGIZWHqM9ZeH7Rv8PX
dm-uuid-LVM-Mn6J1pC3IAss0h6SeXMprDWETuJIO1u1IFQqGeDM7iVgxpsQ6cm5EB2BqPUhX6bh
dm-uuid-LVM-Mn6J1pC3IAss0h6SeXMprDWETuJIO1u1j1XAaN5vwHET3tKQR23zfEbp1RbZCPuK
dm-uuid-LVM-Mn6J1pC3IAss0h6SeXMprDWETuJIO1u1O2ZRvhU09h3yzBTd1f6zw1dHRf0Qo7S5
dm-uuid-LVM-Mn6J1pC3IAss0h6SeXMprDWETuJIO1u1ovnv0hlexflX4BTUjA0xPcci44r1mc8u
dm-uuid-LVM-Mn6J1pC3IAss0h6SeXMprDWETuJIO1u1RfJEbazLLfbZd9HIhywT15SV0xSKhpOX
dm-uuid-LVM-PBcl0Ob6IYesLjLqwD3sSBTyxLksGZQZCrC6hnwkt6YuiuK6LqIdrlyCAOiqGWlc
dm-uuid-LVM-PBcl0Ob6IYesLjLqwD3sSBTyxLksGZQZJjezl04d5raF8ig7sEpwVDb3a6O6aE83
lvm-pv-uuid-7PCs67-4Sui-iGgU-96iF-EEig-scFA-3P3Fqu
lvm-pv-uuid-ZnVpNS-ZBBe-hqfW-mCHz-nHdd-PdRt-wUiIoU
md-name-snowcrash:green
md-uuid-21b822f6:261a0dde:62101e46:1721c196
nvme-eui.002538b111502115
nvme-eui.002538b111502115-part1
nvme-eui.002538b111502115-part2
nvme-eui.002538b111502115-part3
nvme-Samsung_SSD_980_PRO_1TB_S5P2NG0R104509J
nvme-Samsung_SSD_980_PRO_1TB_S5P2NG0R104509J-part1
nvme-Samsung_SSD_980_PRO_1TB_S5P2NG0R104509J-part2
nvme-Samsung_SSD_980_PRO_1TB_S5P2NG0R104509J-part3
wwn-0x5000c500c72479fc
wwn-0x5000c500c724acf4
</pre>

<p>
When setting up a computer to mount a disk, one probably wants to use
<code>/dev/disk/by-uuid/…</code> .  This includes what gets added to <a href="https://www.man7.org/linux/man-pages/man5/fstab.5.html"><code>/etc/fstab</code></a> or
<a href="https://www.freedesktop.org/software/systemd/man/systemd.mount.html">systemd <code>*.mount</code> units</a>.  See also <code>blkid</code> to list disk names next to their UUIDs.  Example listing:
</p>

<pre class="example">
$ ls /dev/disk/by-uuid/
261b43e8-c723-4642-b5eb-44204d778003  397f131d-bd83-4d2a-9c37-9601ed1d0b66  6c6e0ba9-5894-475c-833a-be4f4b3400bc  c6af6618-c8f4-401c-9a8b-5265de07b508
27598b7a-dbfd-4e5a-a5b1-4de8618b66ed  4262a448-bb54-4c48-bb66-af8c9c39a395  704eca58-8f57-4f53-989e-56511d731366  dcf2856e-00b4-4b7f-abd8-da374643c1f4
28D2-FF4B                             5d2bfaaf-1ac0-40f6-9a4b-5195d5dd39df  74e0024f-b4db-4518-ba90-2889f99a2cd0  e4e1f10b-2f47-4717-b439-d5836337a486
</pre>

<p>
For clarity, here is the output of <code>blkid</code>:
</p>

<pre class="example">
$ blkid
/dev/sda: UUID="21b822f6-261a-0dde-6210-1e461721c196" UUID_SUB="3ccf1aa1-3138-5367-1349-959ba89f5bfa" LABEL="snowcrash:green" TYPE="linux_raid_member"
/dev/sdb: UUID="21b822f6-261a-0dde-6210-1e461721c196" UUID_SUB="bd74d02c-d8c7-151a-985d-94863daebac1" LABEL="snowcrash:green" TYPE="linux_raid_member"
/dev/nvme0n1p2: UUID="28D2-FF4B" BLOCK_SIZE="512" TYPE="vfat" PARTLABEL="boot" PARTUUID="91a9f1e5-9187-4bc2-8572-273ac53e70b9"
/dev/nvme0n1p3: UUID="27598b7a-dbfd-4e5a-a5b1-4de8618b66ed" TYPE="crypto_LUKS" PARTLABEL="crypt" PARTUUID="f160a31f-3103-4ece-b3f0-37ed1459e14e"
/dev/mapper/luks-27598b7a-dbfd-4e5a-a5b1-4de8618b66ed: UUID="ZnVpNS-ZBBe-hqfW-mCHz-nHdd-PdRt-wUiIoU" TYPE="LVM2_member"
/dev/mapper/Gentoo-Root: UUID="4262a448-bb54-4c48-bb66-af8c9c39a395" BLOCK_SIZE="4096" TYPE="ext4"
/dev/md127: UUID="704eca58-8f57-4f53-989e-56511d731366" TYPE="crypto_LUKS"
/dev/mapper/Gentoo-Home: UUID="261b43e8-c723-4642-b5eb-44204d778003" BLOCK_SIZE="4096" TYPE="ext4"
</pre>
</div>

<div id="outline-container-org6840c3d" class="outline-3">
<h3 id="org6840c3d"><span class="section-number-3">3.1</span> Exceptions to the rules</h3>
<div class="outline-text-3" id="text-3-1">
<p>
Some exceptions to the above rules include:
</p>

<ul class="org-ul">
<li><p>
When using Logical Volumes, always refer to the Logical Volume by its LVM2
device mapping path.  For example this would be like
<code>/dev/mapper/YOUR_VG-YOUR_LV</code>.  In the above outputs I have a LVM2 VG called
<code>Gentoo</code> and a Logical Volume called <code>Home</code>.  I'd refer to this LV via
<code>/dev/mapper/Gentoo-Home</code>.
</p>

<p>
This is recommended because one can create a LVM2 snapshot of a logical
volume, thereby causing the contents of the disk to be available at two
different locations in the volume group.  This has the nasty habit of causing
confusion when using UUIDs with logical volumes, as the kernel can't know
which volume with the same exact UUID to choose from, and will chose the
wrong one sometimes.  (<a href="https://xan.manning.io/2017/05/29/best-practice-for-mounting-an-lvm-logical-volume-with-etc-fstab.html">See this blog post.</a>)
</p></li>

<li>When (re-)attaching disks to a ZFS ZPool, always use <code>/dev/disk/by-id/…</code>.  Do
<i>not</i> use UUIDs.  This will have unintended consequences; for example ZFS
will create partitions with the same UUIDs across a mirror.  (<a href="https://www.reddit.com/r/zfs/comments/izpy6e/zfs_uuid_question/">See this Reddit
discussion</a>.)</li>
</ul>
</div>
</div>
</div>

<div id="outline-container-org69d37c2" class="outline-2">
<h2 id="org69d37c2"><span class="section-number-2">4</span> Use GNU <code>ddrescue</code></h2>
<div class="outline-text-2" id="text-4">
<p>
This is probably the biggest advice I have, because <code>dd</code> sucks.  Nobody has
time to remember yet another unix tool's esoteric syntax, especially one that
is <a href="http://www.catb.org/jargon/html/D/dd.html">not designed to look like other unix tools</a>.  In most use-cases, <a href="https://www.vidarholen.net/contents/blog/?p=479"><code>dd</code> is
treated like a glorified <code>cat</code></a>.  It does have some <a href="http://www.debianadmin.com/recover-data-from-a-dead-hard-drive-using-dd.html">basic data recovery
features</a>, and a way to <a href="https://www.cyberciti.biz/faq/linux-unix-dd-command-show-progress-while-coping/">show progress</a>, but it's not very easy to work with.
</p>

<p>
Let's say your <code>dd</code> gets interrupted half way doing a disk imaging task.  Time
to start over from the beginning!  Let's say your <code>dd</code> encounters an error.
Sure you could try to get <code>dd</code> to work past that error via <code>conv=noerror</code>, but
why think about that when there are tools that can handle this for you
automatically?  Most importantly <code>dd</code> requires the user to determine the
optimal block size, which is nontrivial, as described in this <a href="https://stackoverflow.com/questions/6161823/dd-how-to-calculate-optimal-blocksize">StackOverflow
post</a>.
</p>

<p>
Enter GNU <code>ddrescue</code>.  It has this feature called the <a href="https://www.gnu.org/software/ddrescue/manual/ddrescue_manual.html#Mapfile-structure">"mapfile"</a>, which is a
sort of journal indicating how much of the input has been copied to the output.
It also is used to indicate where data recovery (if required) was successful
and where it was not.  <code>ddrescue</code> also chooses the optimal block size for you,
so it should run as fast as the system supports.  <code>ddrescue</code> also has robust
recovery facilities.  It attempts a few passes before giving up, each pass is
done in a different way from the previous.  In the few times I've needed this
feature, it has managed to recover some data.  It's not perfect, but it should
be a good start.<sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup>
</p>
</div>

<div id="outline-container-orge7dd900" class="outline-3">
<h3 id="orge7dd900"><span class="section-number-3">4.1</span> ddrescue in action</h3>
<div class="outline-text-3" id="text-4-1">
<p>
Let's start with an easy example.  Let's say you want to migrate your
installation to a new disk.  You could use a cat or dd, or you could use
<code>ddrescue</code> and get all this output, and record the status as you go, in case of
power failure or whatever reasons.
</p>

<ol class="org-ol">
<li>Discover the source and destination disks using the above techniques.
Usually it's just enough to find the files that looks like what you want in
<code>/dev/disk/by-id/</code>, or run <code>lsblk</code>.</li>
<li>Run <code>ddrescue --odirect --force source dest your.mapfile</code>.  If <code>ddrescue</code> is
interrupted for whatever reason, just rerun the same command.  If you use
<code>/dev/disk/by-id/</code> it should do the same exact operation with the same exact
disks. It should also continue where it left off thanks to the mapfile.  The
<code>--force</code> is needed when the output is a device file, or already exists.
The <code>--odirect</code> tells <code>ddrescue</code> to bypass the kernel IO buffering, which
will give a better picture on imaging progression.</li>
</ol>

<p>
That's it.  Here is a screenshot from a recent session:
</p>

<a href="static/image/imaging-ssd.png">

<figure>
<img src="static/image/imaging-ssd.png" alt="imaging-ssd.png">

</figure>
</a>


<p>
Note, this also works for thumb drives, such as in the below screenshot:
</p>

<a href="static/image/how-to-write-a-thumb-drive.png">

<figure>
<img src="static/image/how-to-write-a-thumb-drive.png" alt="how-to-write-a-thumb-drive.png">

</figure>
</a>
</div>

<div id="outline-container-org7cb7438" class="outline-4">
<h4 id="org7cb7438"><span class="section-number-4">4.1.1</span> Get your money's worth - using ddrescue for recovery</h4>
<div class="outline-text-4" id="text-4-1-1">
<p>
Everyone knows they need proper backups, but even with this advice constantly
spouted like gospel, users occasionally lose data due to things like as a
failing disk or faulty controller.  Sometimes it's user error and the user
accidentally deletes data that is not backed up.  <code>ddrescue</code> can help recover
from the former issue where hardware issues cause disk to fail.
</p>

<strong>
<p>
Note: When recovering from a failing disk.  Run <code>ddrescue</code> on the disk, then
make the recovered image file <i>read only</i>.  Make a full (or CoW<sup><a id="fnr.3" class="footref" href="#fn.3">3</a></sup>) copy of the recovered
image file.  Work on this copy.  This way if one messes up fixing the damaged
data on the disk image, it is possible to restart the process without
re-reading the failed disk (which will risk more data loss).
</p>
</strong>

<p>
In most ways the way to run <code>ddrescue</code> is the same when recovering data.
Admittedly I have only had to recover data from one disk recently, and it was
only slightly damaged, but this should work for virtually all use cases.
</p>

<ol class="org-ol">
<li>Discover the source and destination disks like in the above example.</li>
<li>Run <code>ddrescue --idirect source your-dest-file your.mapfile</code>.  Notice there
is no <code>--force</code> or <code>--odirect</code>.  One could add the <code>--odirect</code> back on, but
there isn't necessary, because data recovery takes a long time, and the
bottleneck won't be your destination filesystem's write speed.  The
<code>--idirect</code> tells <code>ddrescue</code> to try to manipulate the disk directly, which
can result in more data recovered (see the info pages).</li>
</ol>

<p>
Here is an excerpt from a screen session demonstrating disk recovery.  This
recovery recovered all but a couple MB of a damaged disk.  I was able to
re-write the image to a new disk, and Windows 10 booted, fixed the filesystem
corruption, and ran fine:
</p>

<pre class="example">
130 root@grml ~ # ddrescue --idirect -r 2 -P /dev/disk/by-id/scsi-SATA_WDC_WD10E
ADS-65M_WD-WCAV5C853599 ~grml/mnt/silo/mnt/backup/bulk/2021-02-21/disk.dd ~grml/
mnt/silo/mnt/backup/bulk/2021-02-21/disk.map
GNU ddrescue 1.23
Press Ctrl-C to interrupt
Initial status (read from mapfile)
rescued: 1000 GB, tried: 14480 kB, bad-sector: 14480 kB, bad areas: 1165

Current status
Data preview:
DBAC28C000  98 00 00 00 02 00 00 00  80 36 00 00 00 00 49 03  .........6....I.
DBAC28C010  B6 1A 07 00 00 00 2B 00  00 90 2E D5 0E 00 00 00  ......+.........
DBAC28C020  82 BB A6 E6 13 BC D5 01  02 00 00 00 00 00 00 00  ................

     ipos:  943486 MB, non-trimmed:        0 B,  current rate:    3072 B/s
     opos:  943486 MB, non-scraped:        0 B,  average rate:      97 B/s
non-tried:        0 B,  bad-sector:    7465 kB,    error rate:       0 B/s
  rescued:    1000 GB,   bad areas:     4943,        run time:     20h 44s
pct rescued:   99.99%, read errors:    26417,  remaining time:      6h  1m
                              time since last successful read:         n/a
Finished
ddrescue --idirect -r 2 -P  ~grml/mnt/silo/mnt/backup/bulk/2021-02-21/disk.dd  6
.73s user 4.34s system 0% cpu 20:00:43.95 total
root@grml ~ #
</pre>

<p>
Notice the data preview in the above (<code>-P</code>).  While non-functional, it can indicate
the sort of data being recovered (e.g. is it mostly zeros or images, etc).
</p>
</div>
</div>
</div>
</div>

<div id="outline-container-org75e017f" class="outline-2">
<h2 id="org75e017f"><span class="section-number-2">5</span> Monitor dmesg for errors</h2>
<div class="outline-text-2" id="text-5">
<p>
Sometimes when doing disk copying, you'll get long hangs.  Some devices,
especially USB attached mass storage devices, will behave strangely, and hang,
then reset the usb link.  If you're lucky the kernel will reassign it the same
device files (e.g. <code>/dev/sdc</code> could show up again as <code>/dev/sdc</code>), but in some
cases it'll show up differently.  Even <code>ddrescue</code> will complain about this and
give up.
</p>

<p>
I usually fire up <code>dmesg --human --follow --reltime</code> in a separate tmux/screen
window.
</p>


<p>
Here's an example of a Thinkpad's disk failing during an upgrade, clearly
indicated in <code>dmesg</code>:
</p>

<a href="static/image/bad-dmesg1.jpg">

<figure>
<img src="static/image/bad-dmesg1.jpg" alt="bad-dmesg1.jpg">

</figure>
</a>
</div>
</div>

<div id="outline-container-org0ce9273" class="outline-2">
<h2 id="org0ce9273"><span class="section-number-2">6</span> Always run your task in a tmux or screen session</h2>
<div class="outline-text-2" id="text-6">
<p>
When you close your terminal, the shell is sent SIGHUP, which then in turn
sends SIGHUP to each process controlled by that shell.  Most tools do not try
to recover from a Hangup, and will exit when possible.  This can have
unintended consequences if you are doing sensitive things such as resizing a
filesystem.
</p>

<p>
One work around is to use <code>nohup</code> which runs the task with the hangup signal
ignored, so the task can continue after the user logs out (or closes terminal).
 See <code>info coreutils nohup</code> or <code>man nohup</code>.  I don't recommend this method, but
it's important to know what choices one has.
</p>

<p>
The best work around is to use either <code>tmux</code> or <code>screen</code> to run your task in a
terminal multiplexer that runs in a terminal emulator.  These tools are
extremely powerful and can do a lot more than what is needed for this use
case.  Just run <code>screen</code>.  You'll get a new shell.  Run your command here.
Type <code>C-a d</code> to detach from the session.  Run <code>screen -rad</code> to re-attach the
session so you can watch progress, such as in case the window was accidentally
closed.  For <code>tmux</code>, just run <code>tmux</code>, then run your command.  Type <code>C-b d</code> to
detach, and run <code>tmux attach-session</code> to reattach to the session.  See <code>man
screen</code> and <code>man tmux</code> for more information.
</p>

<p>
I am naked without a terminal multiplexer.  It's used in virtually every
terminal I open, because it's just a lot easier to work with than dealing with
where the heck I put some random terminal or accidentally closing out my
desktop session.
</p>
</div>
</div>

<div id="outline-container-org518ed30" class="outline-2">
<h2 id="org518ed30"><span class="section-number-2">7</span> Wiping disks</h2>
<div class="outline-text-2" id="text-7">
<p>
There are few options:
</p>

<ul class="org-ul">
<li><code>nwipe /dev/…</code></li>
<li><code>blkdiscard /dev/…</code></li>
<li><code>cat /dev/zero &gt; /dev/…</code></li>
<li><code>shred /dev/…</code></li>
</ul>

<p>
If you're on a SSD, you can probably make do with running a <code>blkdiscard</code> on the
device file (<code>blkdiscard /dev/…</code>).  Be sure to check the manpage <code>man
blkdiscard</code>.
</p>

<p>
If you're using a device that <code>blkdiscard</code> doesn't work with, it might be a
good idea to check out <code>nwipe</code>, which provides a nice Text User Interface (TUI)
to configure the wiping, then do the wipe.  It can do all sorts of erasure
patterns, including some FIPS data security standard.  It can also do a simple
zero-ing.  Fun fact, <code>nwipe</code> is forked from <code>dwipe</code>.  <code>dwipe</code> is  DBAN's secret
sauce; so next time don't use <a href="https://dban.org/">DBAN</a>, just use a general purpose LiveCD with
<code>nwipe</code> bundled, like GRML or systemrescuecd.
</p>


<a href="static/image/nwipe.png">

<figure>
<img src="static/image/nwipe.png" alt="nwipe.png">

</figure>
</a>

<p>
Otherwise just pipe <code>/dev/zero</code> to the device file.  <code>cat</code> or <code>pv</code> (<code>pv</code> shows
progress) will do (try <code>pv /dev/zero &gt; /dev/disk/by-id/…</code>).  An honorable
mention goes to GNU <code>shred /dev/disk/by-id/…</code>, bundled with <a href="https://www.gnu.org/software/coreutils/">Coreutils</a>.  It acts
like a slightly better <code>cat /dev/random &gt; /dev/disk/by-id/…</code>.<sup><a id="fnr.4" class="footref" href="#fn.4">4</a></sup>
</p>
</div>
</div>

<div id="outline-container-orgd48d6b6" class="outline-2">
<h2 id="orgd48d6b6"><span class="section-number-2">8</span> Conclusion</h2>
<div class="outline-text-2" id="text-8">
<p>
I hope this helps describe some of the steps I take when working with disks on
Linux.  Here are some additional resources to look over to learn more:
</p>

<ul class="org-ul">
<li><a href="https://wiki.archlinux.org/index.php/Category:File_systems">Archlinux Wiki - Category:File systems</a></li>
<li><a href="https://wiki.gentoo.org/wiki/Handbook:AMD64/Installation/Disks">Gentoo Handbook:AMD64 - Perparing the Disks</a></li>
<li>Software documentation:
<ul class="org-ul">
<li><a href="https://www.gnu.org/software/ddrescue/manual/ddrescue_manual.html"><code>ddrescue</code> documentation</a> (<code>info ddrescue</code>)</li>
<li><a href="https://www.gnu.org/software/parted/manual/"><code>parted</code> documentation</a> (<code>info parted</code>)</li>
<li><a href="https://www.mankier.com/1/nwipe"><code>nwipe</code> documentation</a> (<code>man nwipe</code>)</li>
<li><a href="https://man.archlinux.org/man/blkdiscard.8.en"><code>blkdiscard</code> documentation</a> (<code>man blkdiscard</code>)</li>
<li><a href="https://www.gnu.org/software/coreutils/manual/html_node/shred-invocation.html"><code>shred</code> documentation</a> (<code>info coreutils shred</code>)</li>
<li><a href="https://man.archlinux.org/man/blkid.8"><code>blkid</code> documentation</a> (<code>man blkid</code>)</li>
<li><a href="https://man.archlinux.org/man/lsblk.8"><code>lsblk</code> documentation</a> (<code>man lsblk</code>)</li>
<li><a href="https://www.gnu.org/software/coreutils/manual/html_node/nohup-invocation.html"><code>nohup</code> documentation</a> (<code>info coreutils nohup</code>)</li>
<li><a href="https://www.man7.org/linux/man-pages/man1/tmux.1.html"><code>tmux</code> documentation</a> (<code>man tmux</code>)  (See also this <a href="https://tmuxguide.readthedocs.io/en/latest/tmux/tmux.html">nice guide</a>.)</li>
<li><a href="https://www.gnu.org/software/screen/manual/screen.html"><code>screen</code> documentation</a> (<code>info screen</code>)</li>
</ul></li>
</ul>
</div>


<div id="outline-container-org7965ebc" class="outline-3">
<h3 id="org7965ebc"><span class="section-number-3">8.1</span> Portability of this article</h3>
<div class="outline-text-3" id="text-8-1">
<p>
Most of what was discussed maps at a high level to other OSes.  For example one
can use <a href="https://www.ithands-on.com/2020/10/freebsd-101-disk-labels.html">GPT partition UUIDs to identify partitions on FreeBSD</a>; a similar
feature <a href="https://www.openbsdhandbook.com/disk_operations/#disklabel-unique-identifiers">exists on OpenBSD</a>.  And for OSes that don't have a UUID feature,
filesystem labels always are an option.  Anything that doesn't depend on the
automatic kernel enumeration of the drives is good in my book (read: no <code>sdX</code>).
</p>

<p>
<code>ddrescue</code> installs on most Unix-likes, though unfortunately <code>parted</code>,
<code>lsblk</code>, <code>nwipe</code>, and <code>blkdiscard</code> are all Linuxy stuff, but there don't appear
to be any nice-to-use cross-patform tools to recommend as an alternative.
Thankfully the concepts map roughly 1:1 (except for weird stuff like BSD disk
labels, which are like LVM2's younger brother.)
</p>

<p>
For the most part, using <code>fdisk -l</code> or similar, paired with <code>dmesg</code> will show
what you need to know about disks on your Unix-like of choice.
</p>
</div>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
<code>fdisk -l</code>, <code>cfdisk -l</code>, <code>gdisk -l</code> work too, but <code>parted</code> has a simple
interface and can do virtually everything the <code>fdisk</code> like tools can do, with a
better interface.
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
It turns out even <code>ddrescue</code> <a href="https://lists.gnu.org/archive/html/bug-ddrescue/2020-10/msg00000.html">isn't perfect</a>.  If it fails you, maybe try
some other tools, or send the drive to be recovered by professionals.
Software, like their authors, is not perfect and infallible.
</p></div></div>

<div class="footdef"><sup><a id="fn.3" class="footnum" href="#fnr.3">3</a></sup> <div class="footpara"><p class="footpara">
Copy on Write.  <a href="https://en.wikipedia.org/wiki/Copy-on-write#In_computer_storage">See Wikipedia</a>.  LVM2, ZFS, BTRFS all support this.
</p></div></div>

<div class="footdef"><sup><a id="fn.4" class="footnum" href="#fnr.4">4</a></sup> <div class="footpara"><p class="footpara">
Thanks to DiffieHellmen for reminding me of GNU <code>shred</code>.
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-computing.html">computing</a> <a href="tag-linux.html">linux</a> </div></div>
<div id="postamble" class="status">
<hr/>
<ul class="inline-list interpunct">
<li>Powered by <a href="https://github.com/bastibe/org-static-blog">org-static-blog</a></li>
<li>Like what I do? <a href="https://www.buymeacoffee.com/winny">Buy me a Coffee</a></li>
</ul>
<p>© Winston Weinert (winny) — <a href="https://creativecommons.org/licenses/by-sa/4.0/legalcode">CC-BY-SA-4.0</a></p>
</div>
</body>
</html>
